Package weka.core

# Class Tee

java.lang.Object
java.io.OutputStream
java.io.FilterOutputStream
java.io.PrintStream
weka.core.Tee

All Implemented Interfaces:
  `Closeable`, `Flushable`, `Appendable`, `AutoCloseable`, `RevisionHandler`

public class Tee extends PrintStream implements RevisionHandler
This class pipelines print/println's to several PrintStreams. Useful for redirecting System.out and System.err to files etc.
E.g., for redirecting stderr/stdout to files with timestamps and:

        import java.io.*;
        import weka.core.Tee;

        ...
        // stdout
        Tee teeOut = new Tee(System.out);
        teeOut.add(new PrintStream(new FileOutputStream("out.txt")), true);
        System.setOut(teeOut);

        // stderr
        Tee teeErr = new Tee(System.err);
        teeErr.add(new PrintStream(new FileOutputStream("err.txt")), true);
        System.setOut(teeErr);
        ...

Version:
  $Revision: 15287 $
Author:
  FracPete (fracpete at waikato dot ac dot nz)

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Tee()`
  initializes the object, with a default printstream.
  `Tee(PrintStream def)`
  initializes the object with the given default printstream, e.g., System.out.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(PrintStream p)`
  adds the given PrintStream to the list of streams, with NO timestamp and NO prefix.
  `void`
  `add(PrintStream p, boolean timestamp)`
  adds the given PrintStream to the list of streams, with NO prefix.
  `void`
  `add(PrintStream p, boolean timestamp, String prefix)`
  adds the given PrintStream to the list of streams.
  `PrintStream`
  `append(char c)`
  Appends the specified character to this output stream.
  `PrintStream`
  `append(CharSequence csq)`
  Appends the specified character sequence to this output stream.
  `PrintStream`
  `append(CharSequence csq, int start, int end)`
  Appends a subsequence of the specified character sequence to this output stream.
  `void`
  `clear()`
  removes all streams and places the default printstream, if any, again in the list.
  `boolean`
  `contains(PrintStream p)`
  checks whether the given PrintStream is already in the list.
  `void`
  `flush()`
  flushes all the printstreams.
  `PrintStream`
  `get(int index)`
  returns the specified PrintStream from the list.
  `PrintStream`
  `getDefault()`
  returns the default printstrean, can be NULL.
  `String`
  `getRevision()`
  Returns the revision string.
  `void`
  `print(boolean x)`
  prints the given boolean to the streams.
  `void`
  `print(char x)`
  prints the given char to the streams.
  `void`
  `print(char[] x)`
  prints the given char array to the streams.
  `void`
  `print(double x)`
  prints the given double to the streams.
  `void`
  `print(float x)`
  prints the given float to the streams.
  `void`
  `print(int x)`
  prints the given int to the streams.
  `void`
  `print(long x)`
  prints the given long to the streams.
  `void`
  `print(Object x)`
  prints the given object to the streams.
  `void`
  `print(String x)`
  prints the given string to the streams.
  `PrintStream`
  `printf(String format, Object... args)`
  A convenience method to write a formatted string to this output stream using the specified format string and arguments.
  `PrintStream`
  `printf(Locale l, String format, Object... args)`
  A convenience method to write a formatted string to this output stream using the specified format string and arguments.
  `void`
  `println()`
  prints a new line to the streams.
  `void`
  `println(boolean x)`
  prints the given boolean to the streams.
  `void`
  `println(char x)`
  prints the given char to the streams.
  `void`
  `println(char[] x)`
  prints the given char array to the streams.
  `void`
  `println(double x)`
  prints the given double to the streams.
  `void`
  `println(float x)`
  prints the given float to the streams.
  `void`
  `println(int x)`
  prints the given int to the streams.
  `void`
  `println(long x)`
  prints the given long to the streams.
  `void`
  `println(Object x)`
  prints the given object to the streams (for Throwables we print the stack trace).
  `void`
  `println(String x)`
  prints the given string to the streams.
  `PrintStream`
  `remove(int index)`
  removes the given PrintStream from the list.
  `PrintStream`
  `remove(PrintStream p)`
  removes the given PrintStream from the list.
  `int`
  `size()`
  returns the number of streams currently in the list.
  `String`
  `toString()`
  returns only the classname and the number of streams.
  `void`
  `write(byte[] b)`
  Writes `b.length` bytes to this output stream.
  `void`
  `write(byte[] buf, int off, int len)`
  Writes `len` bytes from the specified byte array starting at offset `off` to this stream.
  `void`
  `write(int b)`
  Writes the specified byte to this stream.

  ### Methods inherited from class java.io.PrintStream

  `checkError, close, format, format, writeBytes`

  ### Methods inherited from class java.io.OutputStream

  `nullOutputStream`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Tee

    public Tee()
    initializes the object, with a default printstream.

  - ### Tee

    public Tee(PrintStream def)
    initializes the object with the given default printstream, e.g., System.out.
    Parameters:
      `def` - the default printstream, remains also after calling clear()

- ## Method Details

  - ### clear

    public void clear()
    removes all streams and places the default printstream, if any, again in the list.
    See Also:
      - `getDefault()`

  - ### getDefault

    public PrintStream getDefault()
    returns the default printstrean, can be NULL.
    Returns:
      the default printstream
    See Also:
      - `m_Default`

  - ### add

    public void add(PrintStream p)
    adds the given PrintStream to the list of streams, with NO timestamp and NO prefix.
    Parameters:
      `p` - the printstream to add

  - ### add

    public void add(PrintStream p, boolean timestamp)
    adds the given PrintStream to the list of streams, with NO prefix.
    Parameters:
      `p` - the printstream to add
      `timestamp` - whether to use timestamps or not

  - ### add

    public void add(PrintStream p, boolean timestamp, String prefix)
    adds the given PrintStream to the list of streams.
    Parameters:
      `p` - the printstream to add
      `timestamp` - whether to use timestamps or not
      `prefix` - the prefix to use

  - ### get

    public PrintStream get(int index)
    returns the specified PrintStream from the list.
    Parameters:
      `index` - the index of the PrintStream to return
    Returns:
      the specified PrintStream, or null if invalid index

  - ### remove

    public PrintStream remove(PrintStream p)
    removes the given PrintStream from the list.
    Parameters:
      `p` - the PrintStream to remove
    Returns:
      returns the removed PrintStream if it could be removed, null otherwise

  - ### remove

    public PrintStream remove(int index)
    removes the given PrintStream from the list.
    Parameters:
      `index` - the index of the PrintStream to remove
    Returns:
      returns the removed PrintStream if it could be removed, null otherwise

  - ### contains

    public boolean contains(PrintStream p)
    checks whether the given PrintStream is already in the list.
    Parameters:
      `p` - the PrintStream to look for
    Returns:
      true if the PrintStream is in the list

  - ### size

    public int size()
    returns the number of streams currently in the list.
    Returns:
      the number of streams in the list

  - ### flush

    public void flush()
    flushes all the printstreams.
    Specified by:
      `flush` in interface `Flushable`
    Overrides:
      `flush` in class `PrintStream`

  - ### print

    public void print(int x)
    prints the given int to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(long x)
    prints the given long to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(float x)
    prints the given float to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(double x)
    prints the given double to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(boolean x)
    prints the given boolean to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(char x)
    prints the given char to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(char[] x)
    prints the given char array to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(String x)
    prints the given string to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### print

    public void print(Object x)
    prints the given object to the streams.
    Overrides:
      `print` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println()
    prints a new line to the streams.
    Overrides:
      `println` in class `PrintStream`

  - ### println

    public void println(int x)
    prints the given int to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(long x)
    prints the given long to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(float x)
    prints the given float to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(double x)
    prints the given double to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(boolean x)
    prints the given boolean to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(char x)
    prints the given char to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(char[] x)
    prints the given char array to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(String x)
    prints the given string to the streams.
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### println

    public void println(Object x)
    prints the given object to the streams (for Throwables we print the stack trace).
    Overrides:
      `println` in class `PrintStream`
    Parameters:
      `x` - the object to print

  - ### write

    public void write(byte[] buf, int off, int len)
    Writes `len` bytes from the specified byte array starting at offset `off` to this stream. If automatic flushing is enabled then the `flush` method will be invoked.

    Note that the bytes will be written as given; to write characters that will be translated according to the platform's default character encoding, use the `print(char)` or `println(char)` methods.

    Overrides:
      `write` in class `PrintStream`
    Parameters:
      `buf` - A byte array
      `off` - Offset from which to start taking bytes
      `len` - Number of bytes to write

  - ### write

    public void write(int b)
    Writes the specified byte to this stream. If the byte is a newline and automatic flushing is enabled then the `flush` method will be invoked.

    Note that the byte is written as given; to write a character that will be translated according to the platform's default character encoding, use the `print(char)` or `println(char)` methods.

    Overrides:
      `write` in class `PrintStream`
    Parameters:
      `b` - The byte to be written
    See Also:
      - `print(char)`
      - `println(char)`

  - ### write

    public void write(byte[] b) throws IOException
    Writes `b.length` bytes to this output stream.

    The `write` method of `FilterOutputStream` calls its `write` method of three arguments with the arguments `b`, `0`, and `b.length`.

    Note that this method does not call the one-argument `write` method of its underlying output stream with the single argument `b`.

    Overrides:
      `write` in class `PrintStream`
    Parameters:
      `b` - the data to be written.
    Throws:
      `IOException` - if an I/O error occurs.
    See Also:
      - `FilterOutputStream.write(byte[], int, int)`

  - ### printf

    public PrintStream printf(String format, Object... args)
    A convenience method to write a formatted string to this output stream using the specified format string and arguments.

    An invocation of this method of the form `out.printf(format, args)` behaves in exactly the same way as the invocation

             out.format(format, args)

    Overrides:
      `printf` in class `PrintStream`
    Parameters:
      `format` - A format string as described in Format string syntax
      `args` - Arguments referenced by the format specifiers in the format string. If there are more arguments than format specifiers, the extra arguments are ignored. The number of arguments is variable and may be zero. The maximum number of arguments is limited by the maximum dimension of a Java array as defined by The Java™ Virtual Machine Specification. The behaviour on a `null` argument depends on the conversion.
    Returns:
      This output stream
    Throws:
      `IllegalFormatException` - If a format string contains an illegal syntax, a format specifier that is incompatible with the given arguments, insufficient arguments given the format string, or other illegal conditions. For specification of all possible formatting errors, see the Details section of the formatter class specification.
      `NullPointerException` - If the `format` is `null`
    Since:
      1.5

  - ### printf

    public PrintStream printf(Locale l, String format, Object... args)
    A convenience method to write a formatted string to this output stream using the specified format string and arguments.

    An invocation of this method of the form `out.printf(l, format, args)` behaves in exactly the same way as the invocation

             out.format(l, format, args)

    Overrides:
      `printf` in class `PrintStream`
    Parameters:
      `l` - The locale to apply during formatting. If `l` is `null` then no localization is applied.
      `format` - A format string as described in Format string syntax
      `args` - Arguments referenced by the format specifiers in the format string. If there are more arguments than format specifiers, the extra arguments are ignored. The number of arguments is variable and may be zero. The maximum number of arguments is limited by the maximum dimension of a Java array as defined by The Java™ Virtual Machine Specification. The behaviour on a `null` argument depends on the conversion.
    Returns:
      This output stream
    Throws:
      `IllegalFormatException` - If a format string contains an illegal syntax, a format specifier that is incompatible with the given arguments, insufficient arguments given the format string, or other illegal conditions. For specification of all possible formatting errors, see the Details section of the formatter class specification.
      `NullPointerException` - If the `format` is `null`
    Since:
      1.5

  - ### append

    public PrintStream append(char c)
    Appends the specified character to this output stream.

    An invocation of this method of the form `out.append(c)` behaves in exactly the same way as the invocation

             out.print(c)

    Specified by:
      `append` in interface `Appendable`
    Overrides:
      `append` in class `PrintStream`
    Parameters:
      `c` - The 16-bit character to append
    Returns:
      This output stream
    Since:
      1.5

  - ### append

    public PrintStream append(CharSequence csq)
    Appends the specified character sequence to this output stream.

    An invocation of this method of the form `out.append(csq)` behaves in exactly the same way as the invocation

             out.print(csq.toString())

    Depending on the specification of `toString` for the character sequence `csq`, the entire sequence may not be appended. For instance, invoking then `toString` method of a character buffer will return a subsequence whose content depends upon the buffer's position and limit.

    Specified by:
      `append` in interface `Appendable`
    Overrides:
      `append` in class `PrintStream`
    Parameters:
      `csq` - The character sequence to append. If `csq` is `null`, then the four characters `"null"` are appended to this output stream.
    Returns:
      This output stream
    Since:
      1.5

  - ### append

    public PrintStream append(CharSequence csq, int start, int end)
    Appends a subsequence of the specified character sequence to this output stream.

    An invocation of this method of the form `out.append(csq, start, end)` when `csq` is not `null`, behaves in exactly the same way as the invocation

             out.print(csq.subSequence(start, end).toString())

    Specified by:
      `append` in interface `Appendable`
    Overrides:
      `append` in class `PrintStream`
    Parameters:
      `csq` - The character sequence from which a subsequence will be appended. If `csq` is `null`, then characters will be appended as if `csq` contained the four characters `"null"`.
      `start` - The index of the first character in the subsequence
      `end` - The index of the character following the last character in the subsequence
    Returns:
      This output stream
    Throws:
      `IndexOutOfBoundsException` - If `start` or `end` are negative, `start` is greater than `end`, or `end` is greater than `csq.length()`
    Since:
      1.5

  - ### toString

    public String toString()
    returns only the classname and the number of streams.
    Overrides:
      `toString` in class `Object`
    Returns:
      only the classname and the number of streams

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Returns:
      the revision